import json
import sys

from russell.client.base import RussellHttpClient
from russell.client.files import get_files_in_directory
from russell.log import logger as russell_logger
from russell.client.auth import AuthClient

class ProjectClient(RussellHttpClient):
    """
    Client to interact with projects api
    """
    def __init__(self):
        self.url = "/projects/"
        super(ProjectClient, self).__init__()

    def clone(self, project_url_or_id, compression='zip', uncompress=True, delete_after_uncompress=True):
        """
        Download and optionally untar the tar file from the given url
        """
        try:
            project_name = self.get_project_name(project_url_or_id)

            url = self.url + 'clone/' + project_url_or_id
            self.download_compressed(url,
                                     compression=compression,
                                     uncompress=uncompress,
                                     delete_after_uncompress=delete_after_uncompress,
                                     dir=project_name)
        except Exception as e:
            russell_logger.info("Download URL ERROR! {}".format(e))
            return False

    def create(self, project):
        pass

    def delete(self, id):
        pass
        return True

    def get_project_name(self,id):
        project = self.request('GET',
                               url='/anonymous/project/anonymous',
                               params={'id':id})
        return project.get('name')